start clufdeuc(outtree,w,n,gkat,titre);
call execute('use ',outtree,' var {idobs cluster clusname};');
read all; close; m=int(sqrt(2*n)+1); if n=50 then m=10; r=mod(n,m); q=(n-r)/m;
if r=0  then rg=2*q-1; else rg=2*q+1; d=j(n,3,0); nu=n; b={0 0 1 1}; a=j(1,4,0);
do k=1 to n; v=voisfic(k,n,1);
do j=1 to nrow(v)*ncol(v); d[k,j]=sqrt((w[,k]-w[,v[j]])[##]);end; end;
if 95/m-int(95/m)>=.5 then pv=int(95/m)+.5; else pv=int(95/m);
if 100/m-int(100/m)>=.5 then ph=int(100/m)+.5; else ph=int(100/m);
d=d/d[<>]; xbox={0 0 1 1}; ybox={0 1 1 0};
colors={'lipk','vliv','lig','vlibg','lio','ligr','rose','steel',
        'paoy','vligb','ligrpr','vpav','lippk','liybr','paypk','lilg',
        'lilac','vpag','brown','pink','liolgr','libg'};
nclus=ncol(unique(clusname)); ncoul=nrow(colors); ttcol='black';
if nclus> ncoul then
do;   print " " /;
   print "----------------------------------------------------------";
   print "                  ** AVERTISSEMENT **                     ";
   print " LE NOMBRE DE CLUSTERS > LE NOMBRE DE COULEURS DISPONIBLES";
   print "----------------------------------------------------------";
   return;
end;
call gstart(gkat,1); call gopen("CLUFDEUC",0,titre);
call gstrlen(l,titre); call gscript(50-l/2,97,titre,,,1.25,'swissb','r');
do j=1 to rg by 2;
 if j^=rg | (j=rg & r=0) then
   do i=1 to m;
     x={0 .5 1 .7 1 .5 0 .3 0}; y={1 1 1 .5 0 0 0 .5 1};
     a[1]=(j-1)*ph; a[2]=95.25-i*pv; a[3]=j*ph; a[4]=95.25-(i-1)*pv;
     call gwindow(b); call gport(a);
     k=i+int(j/2)*m; q=loc(idobs=concat("No",char(k,taille(n))));
     jj=cluster[q];coul=colors[jj];
     if k=1 then do; x[1]=x[8]; x[9]=x[8]; x[2]=.5; x[3]=x[4];
        y[1]=y[8]; y[9]=y[8]; y[2]=.5; y[3]=y[4]; y[6]=d[k,2]/2; end;
     if k=nu then do; x[5]=x[4]; x[7]=x[8]; x[6]=.5;
        y[5]=y[4]; y[7]=y[8]; y[6]=.5; y[2]=1-d[k,1]/2; end;
     if k^=1 & k^=nu then do; y[2]=1-d[k,1]/2; y[6]=d[k,3]/2; end;
     call gpoly(xbox,ybox,,ttcol); call gpoly(x,y,,coul,'solid',coul);
   end;
 if j=rg & r^=0  then
   do i=1 to r;
     x={0 .5 1 .7 1 .5 0 .3 0}; y={1 1 1 .5 0 0 0 .5 1};
     a[1]=(j-1)*ph; a[2]=95.25-i*pv; a[3]=j*ph; a[4]=95.25-(i-1)*pv;
     call gwindow(b); call gport(a);
     k=i+int(j/2)*m; q=loc(idobs=concat("No",char(k,taille(n))));
     jj=cluster[q];coul=colors[jj];
     if k=1 then do; x[1]=x[8]; x[9]=x[8]; x[2]=.5; x[3]=x[4];
        y[1]=y[8]; y[9]=y[8]; y[2]=.5; y[3]=y[4]; y[6]=d[k,2]/2; end;
     if k=nu then do; x[5]=x[4]; x[7]=x[8]; x[6]=.5;
        y[5]=y[4]; y[7]=y[8]; y[6]=.5; y[2]=1-d[k,1]/2; end;
     if k^=1 & k^=nu then do; y[2]=1-d[k,1]/2; y[6]=d[k,3]/2; end;
     call gpoly(xbox,ybox,,ttcol); call gpoly(x,y,,coul,'solid',coul);
   end;
end;
call gclose; call gshow("CLUFDEUC"); call gstop;
finish clufdeuc;
store module=clufdeuc;
