start ddw(w,icl,m,titre,gkat,r);
/* distance dx-dy pour les unites gagnantes d'une grille */
/* m = nombre de lignes de la grille */
/* valeurs entre 0 et 1              */
ng=nrow(icl)*ncol(icl); wg=w[,icl];
d=j(ng,ng,0); dw=d;
do i=1 to ng;
    iy=mod(icl[i],m);
    if iy=0 then do; iy=m; ix=icl[i]/m; end;
            else  ix=(icl[i]-iy)/m+1;
 do j=1 to i;
     jy=mod(icl[j],m);
     if jy=0 then do; jy=m; jx=icl[j]/m; end;
             else  jx=(icl[j]-jy)/m+1;
     d[i,j]=sqrt((ix-jx)##2+(iy-jy)##2);
     dw[i,j]=sqrt((wg[,i]-wg[,j])[##]);
 end;
end;
d=d[loc(d)]; d=d/d[<>];
dw=dw[loc(dw)]; dw=dw/dw[<>];
call gstart(gkat,r); call gopen("dx_dy",0,titre);
call gstrlen(l,titre);
call gscript(50-l/2,90,titre,,,2,'swissb','red');
call gwindow({0 0 2 2});
call gport({20 20 80 80});
call gxaxis({0 0},2,10); call gyaxis({0 0},2,10);
call gdraw({0 2},{2 2},1,'black');
call gdraw({2 2},{0 2},1,'black');
call gdraw({0 2},{0 2},1,'blue');
call gpoint(d,dw,'circle','green',1.5);
call gclose; call gshow; call gstop;
finish ddw;
store module=ddw;
