start kdafc(ws,us,e,w0,u0,m,n,tmax);
p=nrow(e); q=ncol(e); nu=m*n;
if nrow(w0)^=p | ncol(w0)^=nu then return;
if nrow(u0)^=q | ncol(u0)^=nu then return;
eps0=.3; c0=.2;
ws=j(p,nu,0); us=j(q,nu,0);
w=w0; u=u0;
ec=pkor(e); el=pkor(e`);
do t=1 to tmax;
  jj=floor(q*uniform(1)+1);   /* on tire un individu dans EC */
  x=ec[,jj];
  zx=el[,ec[,jj][<:>]];       /* sa modalite associee la + rare */
  k=sqrt((w-repeat(x,1,nu))[##,])[>:<];     /* le gagnant de l'individu */
  epst=eps0/(1+c0*t/nu);                    /* sur wp (=w) */
  r=rayon(m,n,tmax,t);
  if r>.5  then v=grivois(k,m,n,r);
  if r=.5  then v=voisgdmi(k,m,n);
  if r=0   then v=k;
  ws=w; us=u;
  do j=1 to nrow(v)*ncol(v);   /* mise a jour pour le gagnant & voisins */
    ws[,v[j]]=w[,v[j]]+epst*(x-w[,v[j]]);   /* sur wp & wq */
    us[,v[j]]=u[,v[j]]+epst*(zx-u[,v[j]]);
  end;
  w=ws; u=us;
  ii=floor(p*uniform(1)+1);  /* on tire une modalite dans EL */
  z=el[,ii];
  o=sqrt((u-repeat(z,1,nu))[##,])[>:<];  /* son gagnant dans wq */
  if r>.5  then s=grivois(o,m,n,r);
  if r=.5  then s=voisgdmi(o,m,n);
  if r=0   then s=o;
  ws=w; us=u;
  do j=1 to nrow(s)*ncol(s);  /* mise a jour pour le gagnant & voisins */
    us[,s[j]]=u[,s[j]]+epst*(z-u[,s[j]]);  /* pour wq SEULEMENT */
  end;
 w=ws; u=us;
end;
finish kdafc;
store module=kdafc;
