start kofdisj(lib,e,modal,indiv);
label=modal//indiv; run ficelle(n,tmax,crnd,cener); nu=n; run declar(cat,cdd);
if length(cat)<5 then cat=concat(cat,cshape('X',1,1,5-length(cat)));
if crnd='O' then seed=2112; else seed=0;
p=nrow(e); q=ncol(e); ec=pkor(e); el=pkor(e`);
minec=min(ec); maxec=max(ec); minel=min(el); maxel=max(el);
wp0=uniform(j(p,nu,seed)); wp0=wp0*(maxec-minec)+minec;
wq0=uniform(j(q,nu,seed)); wq0=wq0*(maxel-minel)+minel;
if cener='O' then do; run kdafcnf(pot,wp,wq,e,wp0,wq0,nu,tmax);
potindiv=pot[tmax,1]; potmodal=pot[tmax,2]; reset noname; print " "/;
print " Valeur finale de la Variance Intra";
print " =>> Pour les individus : " potindiv [format=11.5];
print " =>> Pour les modalites : " potmodal [format=11.5];
print " ";
print " PRENDRE CELLE DES INDIVIDUS POUR UNE COMPARAISON AVEC KACM1(2)";
reset name; end;
if cener='N' then run kdafcf(wp,wq,e,wp0,wq0,nu,tmax);
coindiv=codbk(wp,ec,nu); comod=codbk(wq,el,nu); code=comod//coindiv;
iclp=unique(coindiv)`; iclq=unique(comod)`; icl=unique(code)`;
bigws=wp//wq; eff=rconte(code,nu); efi=rconte(coindiv,nu); efm=rconte(comod,nu);
dubig=max(nrow(wp),nrow(wq)); ws=wp; ee=ec;  dimw=nrow(ws);
D=e`;  B=e*D; x=code||(B//D); nacol='_codage_'//label; xe=coindiv||el;
run tablesas(lib,cat,x,nacol,label);
       /* construction de la table <<IN>> */
fent=concat(substr(cat,1,5),'_IN'); run tablesas(lib,fent,xe,nacol,indiv);
fcla=concat(substr(cat,1,5),'_CL');
run prepar(rep,nvar,nobs,code,eff,icl,label);
if max(eff)<=50 then run tablesas(lib,fcla,rep,nvar,nobs);
		else run tablesas(lib,fcla,rep`,nobs,nvar);
fws=concat(substr(cat,1,5),'_WS');
cell=char(j(nu,1,0)); do k=1 to nu; cell[k]=concat("No",char(k,taille(nu))); end;
pdf=eff||ws`; yvc='effectif'//label; run tablesas(lib,fws,pdf,yvc,cell);
	/* construction de la table <<NB>> */
fnb=concat(substr(cat,1,5),'_nb');
nbv=efi||efm||eff; vcol='individus'//'modalites'//'total';
run tablesas(lib,fnb,nbv,vcol,cell);
titact=concat('KDISJ : ficelle ',trim(left(char(nu))),
			' pour ',trim(left(char(tmax))),' iterations');
act=titact; titp='Representants (Poids Finaux) pour les individus';
info='FICELLE'||'KDISJ'; finf=concat('INFO_',upcase(cat));
run tablesas(lib,finf,info,'RESEAU'//'ALGO','obs1');
titq='Representants (Poids Finaux) pour les modalites';
titind=concat('Individu Moyen & Representant des ',trim(left(char(nu))),' cellules');
titmod=concat('Modalite Moyenne & Representant des ',trim(left(char(nu))),' cellules');
gkat=concat(lib,'.gacm',substr(cat,1,4));
call execute("reset storage=",lib,".",cat,";");
remove _all_; store _all_; remove nacol yvc x xe pdf k seed;
if nu>50 then print "pas de graphique pour une ficelle de plus de 50 unites";
if dimw<=50 & nu>10 & nu<=50  then 
do;
 run filpah(code,label,4.75,nu,gkat,titact);
 run filpah(comod,modal,4.75,nu,gkat,titact);
 run linfic(wp,1:ncol(wp),nu,gkat,titp,modal,0);
 run fcellw(el,ws,coindiv,nu,gkat,titind);
 run linfic(wq,1:ncol(wq),nu,gkat,titq,indiv,0);
 run fcellw(ec,wq,comod,nu,gkat,titmod);
 run frikmaha(ee,ws,coindiv,efi,nu,gkat,1);
 run frik(ws,coindiv,nu,gkat,0);
end;
if dimw<=50 & nu<=10  then 
do;
 run filpah10(code,label,4.75,nu,gkat,titact);
 run filpah10(comod,modal,4.75,nu,gkat,titact);
 run linf10(wp,1:ncol(wp),nu,gkat,titp,modal,0);
 run fcellw10(el,ws,coindiv,nu,gkat,titind);
 run linf10(wq,1:ncol(wq),nu,gkat,titq,indiv,0);
 run fcellw10(ec,wq,comod,nu,gkat,titmod);
 run frik10ma(ee,ws,coindiv,efi,nu,gkat,1);
 run frik10(ws,coindiv,nu,gkat,0);
end;
if dimw>50 & nu<=50  then 
do;
 run filpah(code,label,4.75,nu,gkat,titact);
 run filpah(comod,modal,4.75,nu,gkat,titact);
 run linfic(wp,1:ncol(wp),nu,gkat,titp,modal,0);
 run fcellw(el,ws,coindiv,nu,gkat,titind);
 run linfic(wq,1:ncol(wq),nu,gkat,titq,indiv,0);
 run fcellw(ec,wq,comod,nu,gkat,titmod);
 run frikmaha(ee,ws,coindiv,efi,nu,gkat,1);
 run frik(ws,coindiv,nu,gkat,0);
end;
if cdd='O' then  do; run ddwf(wp,iclp,'DX-DY pour les individus',gkat,0);
		     run ddwf(wq,iclq,'DX-DY pour les modalites',gkat,0); end;
if cener='O' then  do;
       call gstart(gkat,0);
       run grol(pot[,1],'Variance intra etendue aux voisins pour les individus');
       run grol(pot[,2],'Variance intra etendue aux voisins pour les modalites');
       call gstop; end;
finish kofdisj;
store module=kofdisj;
