start kxfacp(e,ident,lib,idvar);
/* p= nbre d'observations, q=nbre de variables */
p=nrow(e); q=ncol(e);
if p<q then do; print "  ";
            print "_______________________________________________________";
            print "      >>>>>   AVERTISSEMENT                            ";
            print "le nombre de variables depasse le nombre d'observations";
            print "_______________________________________________________";
            end;
run ficelle(n,tmax,crnd,cener); run dxclar(cat); run pretr(cpre); nu=n; dimw=q;
if crnd='O' then seed=1212; else seed=0; w0=uniform(j(q,nu,seed));
if cpre='A' then ee=e`; if cpre='C' then ee=centr(e)`; if cpre='N' then ee=zered(e)`;
max=max(ee); min=min(ee); w0=w0*(max-min)+min;
if cener='O' then do; run kxfoen1(pot,ws,ee,w0,n,tmax); potfin=nrj0f(ws,ee,n,0); end;
if cener='N' then do; ws=kxfoe1(ee,w0,n,tmax); potfin=nrj0f(ws,ee,n,0); end;
reset noname; print " "/; print " Valeur finale de la Variance Intra";
print " ==>> " potfin [format=11.5]; reset name;
code=xcodbk(ws,ee,n); label=ident; icl=unique(code)`; eff=rconte(code,n);
run complx(cee,nmiss,tmiss,code,ee,ws);  run missrep(wmiss,twmiss,code,nu,nmiss);
varws=variance(ws)`; vavert=varvert(cee,ws,code);
if length(cat)<5 then cat=concat(cat,cshape('X',1,1,5-length(cat)));
gkat=concat(lib,'.gacp',substr(cat,1,4)); datcmp=concat(substr(cat,1,4),'_CMP');
datwmq=concat(substr(cat,1,4),'_WMQ');
fws=concat(substr(cat,1,5),'_WS'); fcla=concat(substr(cat,1,5),'_CL');
run prepar(rep,nvar,nobs,code,eff,icl,ident);
cell=char(j(nu,1,0));
do k=1 to nu; cell[k]=concat("No",char(k,taille(nu))); end;
pdf=eff||ws`; yvc='effectif'//idvar;
if cpre='A' then do; ivc='_codage_'//idvar; x=code||ee`;  zidvar=' '; end;
            else do; zidvar=concat('Z',idvar); ivc='_codage_'//idvar//zidvar;
                     x=code||e||ee`;
                 end;
if max(eff)<=50
then run tablesas(lib,fcla,rep,nvar,nobs); else run tablesas(lib,fcla,rep`,nobs,nvar);
run tablesas(lib,fws,pdf,yvc,cell); run tablesas(lib,cat,x,ivc,ident);
run tablesas(lib,datcmp,code||nmiss||tmiss||cee`,
                 '_codage_'//'Nb_Miss'//'Tx_Miss'//idvar,ident);
run tablesas(lib,datwmq,eff||wmiss||twmiss||varws||vavert,
                 'effectif'//'Nb_Miss'//'Tx_Miss'//'Var_Hor'//'Var_Vert',cell);
titact=concat('KACPX : ficelle de ',trim(left(char(nu))),
              ' pour ',trim(left(char(tmax))),' iterations');
act=titact; titws='Representants des classes (Poids Finaux)';
info='FICELLE'||'KACPX'; finf=concat('INFO_',upcase(cat));
run tablesas(lib,finf,info,'RESEAU'//'ALGO','obs1');
call execute("reset storage=",lib,".",cat,";");
remove _all_; store _all_; remove ivc yvc x k pdf nvar seed zidvar;
if nu>50 then print "pas de graphique pour une ficelle de plus de 50 unites";
titre=concat('Valeur Moyenne & Representant des ',trim(left(char(nu))),' cellules');
if dimw<=50 & nu>10 & nu<=50 then   do;
run filpah(code,ident,4.75,nu,gkat,titact); run frik(ws,code,nu,gkat,1);
run linfic(ws,1:ncol(ws),nu,gkat,titws,idvar,0);
run hisfic(ws,1:ncol(ws),nu,gkat,titws,idvar,0);
run funit(cee`,code,nu,gkat,idvar); run fcellw(cee`,ws,code,nu,gkat,titre);
                                    end;
if dimw<=50 & nu<=10  then   do;
run filpah10(code,ident,4.75,nu,gkat,titact); run frik10(ws,code,nu,gkat,1);
run linf10(ws,1:ncol(ws),nu,gkat,titws,idvar,0);
run hisf10(ws,1:ncol(ws),nu,gkat,titws,idvar,0);
run funit10(cee`,code,nu,gkat,idvar); run fcellw10(cee`,ws,code,nu,gkat,titre);
                             end;
if dimw>50 & nu<=50  then           do;
run filpah(code,ident,4.75,nu,gkat,titact); run frik(ws,code,nu,gkat,1);
run linfic(ws,1:ncol(ws),nu,gkat,titws,idvar,0);
run funit(cee`,code,nu,gkat,idvar); run fcellw(cee`,ws,code,nu,gkat,titre);
                                    end;
if cener='O'
then  do; call gstart(gkat,1); run grol(pot,'Variance intra etendue aux voisins');
                  call gstop; end;
finish kxfacp;
store module=kxfacp;

