start diskret(lib);
dsn=datasets(lib);
run queldon(iddat,dsn);
call execute("use ", lib,".",iddat,";");
noms=contents();
run choivad(idobs,idvar,noms);
read all var idvar into data;
read all var idobs into ident;
close;
run nbinter(nint);
if type(ident)='N' then ident=char(ident,taille(max(ident)));
run camiss(ident);
run missnum(data);
if nint= 2 then run median(tradat,bornes,data);
if nint= 4 then run quartile(tradat,bornes,data);
if nint= 8 then run quant8(tradat,bornes,data);
if nint^=2 & nint^=4 & nint^=8 then run quantile(tradat,bornes,data,nint);
numero=char(1:nint+1,taille(max(nint+1)));
print " "/;
print ">>> AFFICHAGE DES BORNES DES INTERVALLES <<<";
print bornes[colname=idvar rowname=numero];
t_idvar=concat('T_',idvar);
iddat=trim(left(iddat));
if length(iddat)>=20 then iddat=substr(iddat,1,19);
fict=concat(iddat,'_TR');
run tablesas(lib,fict,data||tradat,idvar//t_idvar,ident);
nvar=ncol(bornes); nlig=nint*nvar;
binf=j(nlig,1,0); bsup=binf; codage=binf;
varident=j(nlig,1,cshape('x',1,1,max(length(idvar))));
fin=do(nint,nlig,nint); deb=fin-nint+1;
fix1=deb[1]:fin[1]; fix2=fix1+1;
do k=1 to nvar;
 range=deb[k]:fin[k];
 binf[range]=bornes[fix1,k]; bsup[range]=bornes[fix2,k];
 varident[range]=idvar[k]; codage[range]=1:nint;
end;
print ">>> AFFICHAGE DES BORNES ET DU CODAGE <<<";
print  varident binf bsup codage;
tabcod=concat(iddat,'_table_codage');
run tablesas(lib,tabcod,binf||bsup||codage,
                                 'BORNE_INF'//'BORNE_SUP'//'CODAGE',varident);
finish diskret;
store module=diskret;

