start clufcoul(outtree,rep,n,gkat,titre);
call execute('use ',outtree,' var {idobs cluster clusname};');
read all; close;
m=int(sqrt(2*n)+1); if n=50 then m=10; r=mod(n,m); q=(n-r)/m;
if r=0  then rg=2*q-1; else rg=2*q+1;
if 95/m-int(95/m)>=.5 then pv=int(95/m)+.5; else pv=int(95/m);
if 100/m-int(100/m)>=.5 then ph=int(100/m)+.5; else ph=int(100/m);
b={0 0 1 1}; a=j(1,4,0); p=nrow(rep); xbox={0 0 1 1}; ybox={0 1 1 0};
xx=j(p+2,1,0); yy=xx;
mini=min(rep); maxi=max(rep); range=max(rep)-min(rep);
dd=(rep-mini)/range; ww=.95*dd+.025; t=do(0,1,1/(p-1))`;
colors={'lipk','vliv','lig','vlibg','lio','ligr','rose','steel',
        'paoy','vligb','ligrpr','vpav','lippk','liybr','paypk','lilg',
        'lilac','vpag','brown','pink','liolgr','libg'};
nclus=ncol(unique(clusname));
ncoul=nrow(colors);
if nclus> ncoul then
do;
   print " " /;
   print "----------------------------------------------------------";
   print "                  ** AVERTISSEMENT **                     ";
   print " LE NOMBRE DE CLUSTERS > LE NOMBRE DE COULEURS DISPONIBLES";
   print "----------------------------------------------------------";
   return;
end;
call gstart(gkat,1); call gopen("CLUFCOUL",0,titre);
call gstrlen(l,titre);
call gscript(50-l/2,97,titre,,,1.25,'swissb','r');
do j=1 to rg by 2;
 if j^=rg | (j=rg & r=0) then
    do i=1 to m;
    a[1]=(j-1)*ph; a[2]=95.25-i*pv; a[3]=j*ph; a[4]=95.25-(i-1)*pv;
    call gwindow(b); call gport(a); k=i+int(j/2)*m;
    x=loc(idobs=concat("No",char(k,taille(n))));
    jj=cluster[x];coul=colors[jj]; z=ww[,k];
    do l=1 to p; xx[l+1]=t[l]; yy[l+1]=z[l]; end; xx[p+2]=1;
    call gpoly(xbox,ybox,,'black');
    call gpoly(xx,yy,,'black','solid',coul);
    end;
 if j=rg & r^=0  then
    do i=1 to r;
    a[1]=(j-1)*ph; a[2]=95.25-i*pv; a[3]=j*ph; a[4]=95.25-(i-1)*pv;
    call gwindow(b); call gport(a); k=i+int(j/2)*m;
    x=loc(idobs=concat("No",char(k,taille(n))));
    jj=cluster[x];coul=colors[jj]; z=ww[,k];
    do l=1 to p; xx[l+1]=t[l]; yy[l+1]=z[l]; end; xx[p+2]=1;
    call gpoly(xbox,ybox,,'black');
    call gpoly(xx,yy,,'black','solid',coul);
    end;
end;
call gclose; call gshow("CLUFCOUL"); call gstop;
finish clufcoul;
store module=clufcoul;
