start deug(lib,tdis,w,icl);
/* calcul des Distances Euclidiennes entre les Unites Gagnantes
   en entree : la matrice de poids = w (p,nu)
               liste des numeros des unites gagnantes = icl
   en sortie : la table sas = lib.tdis
               de card(icl) observations et card(icl)+1 variables
               qui est directement utilisable par la proc MDS
*/
k=ncol(icl)*nrow(icl);
ww=w[,icl];
clas=char(icl,taille(max(icl)));
cell=char(j(k,1,0));
do i=1 to k; cell[i]=concat("No",clas[i]); end;
dw=j(k,k,0);
do i=1 to k;
   do j=1 to k;
       dw[i,j]=sqrt((ww[,i]-ww[,j])[##]);
   end;
end;
call execute("create ",lib,".",tdis," from dw [rowname=cell colname=cell];");
append from dw[rowname=cell]; close;
finish deug;
store module=deug;
