start fcolux10(dat,code,cluster,color,n,gkat);
/* Contenu des unites d'une ficelle <= 10 noeuds */
/* + couleurs des clusters */
if 100/n-int(100/n)>=.5 then ph=int(100/n)+.5; else ph=int(100/n);
xbox={0 0 1 1}; ybox={0 1 1 0};
if n<=7 then ch=1.25; else ch=1.5;
colors={'lipk','vliv','lig','vlibg','lio','ligr','rose','steel',
        'paoy','vligb','ligrpr','vpav','lippk','liybr','paypk','lilg',
        'lilac','vpag','brown','pink','liolgr','libg'};
nclus=max(cluster); ncoul=nrow(colors);
if nclus> ncoul then
do;
   print " " /;
   print "----------------------------------------------------------";
   print "                  ** AVERTISSEMENT **                     ";
   print " LE NOMBRE DE CLUSTERS > LE NOMBRE DE COULEURS DISPONIBLES";
   print "----------------------------------------------------------";
   return;
end;
b={0 0 1 1}; a=j(1,4,0); p=ncol(dat);
mini=min(dat); maxi=max(dat); range=max(dat)-min(dat);
dd=(dat-mini)/range;
dd=.95*dd+.025;
t=do(0,1,1/(p-1))`;
titre=concat('Contenu des ',trim(left(char(n))),' cellules & Clusters');
call gstart(gkat,1); call gopen("CCOL",0,titre);
call gstrlen(l,titre);
call gscript(50-l/2,93,titre,,,1.6,'swissb','red');
  do j= 1 to n;
    a[1]=(j-1)*ph; a[2]=90-ch*ph;
    a[3]=j*ph;     a[4]=90;
    call gwindow(b); call gport(a);
    nc=color[j]; call gpoly(xbox,ybox,,'black','solid',colors[nc]);
    nclas=ncol(loc(code=j));
    if nclas=0 then go to saut;
    ddclas=dd[loc(code=j),];
    do k=1 to nclas;
        z=ddclas[k,];
        call gdraw(t,z,1,'black');
    end;
    saut : call gpoly(xbox,ybox,,'black');
  end;
call gclose; call gshow("CCOL"); call gstop;
finish fcolux10;
store module=fcolux10;


