start kxfoen1(pot,ws,e,w0,n,tmax);
p=nrow(e); q=ncol(e); nu=n;
if nrow(w0)^=p | ncol(w0)^=nu then return;
eps0=.3; c0=.2;
ws=j(p,nu,0); w=w0; pot=j(tmax,1,0);
t=1;
do while (t<=tmax);
  r=rayon(nu,n,tmax,t);
  pot[t]=nrj0f(w,e,n,r);
  x=e[,floor(q*uniform(1)+1)];
  if x=. then goto saut;
  at=loc(x^=.); nat=ncol(at);
  k=sqrt((w-repeat(x,1,nu))[##,])[>:<];
  epst=eps0/(1+c0*t/nu);
  if r>.5  then v=voisfic(k,n,r);
  if r=.5  then v=voisfic(k,n,1);
  if r=0   then v=k;
  ws=w;
  do j=1 to nrow(v)*ncol(v);
   do i=1 to nat;
     ws[at[i],v[j]]=w[at[i],v[j]]+epst*(x[at[i]]-w[at[i],v[j]]);
   end;
  end;
  w=ws;
  saut: t=t+1;
end;
finish kxfoen1;
store module=kxfoen1;
