%*libname k 'u:\k8\akor';
options nocenter nodate ls=78  ps=200 mprint SASMSTORE=k mstored;
%window camficel  rows=26 columns=100 color=cyan
#1 @20 "Pour abandonner taper O dans le champ STOP =" +1 stop 1 attr=rev_video
#3 @20 "COMPLEMENTS KACP,KACPX,KFAST,KBATCH POUR UNE FICELLE (>10 & <=50)" color=magenta
#4 @20 "=>>> CAMEMBERTS POUR UNE VARIABLE QUALITATIVE SUR PAVAGE EN CLUSTERS"
        attr=underline
#6 @3 "nom de la librairie  (par defaut u:\k8\aboul) "
#7 @3 "nom commun           (par defaut _TEMPOR_) "
#8 @3 "nombre de clusters   (le nombre de super-classes de MKLUF2) "
#9 @3 "(contrainte : le nombre de clusters doit etre <=22 )"
#12 @10 "librairie  :" +2 lib   40 attr=rev_video
#14 @10 "nom commun :" +2 nom  8 attr=rev_video
#16 @10 "nombre de clusters :" +2 nc 2 attr=rev_video
#20 @63 "Valider vos choix avec la touche F3" color=magenta
#21 @37 "En cas de NON sortie consulter les messages de la fenetre LOG "
         color=magenta;
%macro mkamf2 / store des="camemberts (f>10) pour var. qualitative";
%local nom lib stop tabws taclus catiml gcat ok nc ok1 ok2 ok3 ok4;
%let err=0; %let stop=; %let lib=u:\k8\aboul; %let nom=_TEMPOR_; %let nc=;
%let ok=0; %let ok1=0; %let ok2=0; %let ok3=0; %let ok4=0;
%do %until(&ok=1);
%display camficel;
%let stop=%upcase(&stop); %if &stop=  %then %let ok1=1;
%if &stop=O %then %goto arret;
%if &stop^=O and &stop^=  %then
%do; %let ok1=0; %put ne taper pas  &stop mais O pour abandonner; %goto test; %end;
%str(libname a "&lib";);
%if  (%sysfunc(libref(a))) %then %put %str(le repertoire &lib n%'existe pas !);
%let nom=%upcase(&nom);
%if %length(&nom)<5
%then  %do j=1 %to %eval(5-%length(&nom)); %let nom=&nom.X; %end;
%let catiml=a.&nom;
%if  %sysfunc(cexist(&catiml)) %then %let ok2=1;
                               %else
%do; %put %str(le catalogue iml &catiml n%'existe pas !); %let ok2=0; %end;
%let taclus=a.CLUSF&nc;
%if  %sysfunc(exist(&taclus)) %then %let ok3=1;
%else %do; %put %str(la table &taclus n%'existe pas !); %let ok3=0; %end;
%let gcat=a.GACP%substr(&nom,1,4);
%if %sysfunc(cexist(&gcat)) %then %let ok4=1;
                            %else
%do; %put %str(le catalogue graphique &gcat n%'existe pas !); %let ok4=0; %end;
%let tabws=a.%substr(&nom,1,5)_WS;
%test: %put %str();
%if &ok1=1 and &ok2=1 and &ok3=1 and &ok4=1 %then %let ok=1;
%else %do; %let stop=; %let lib=u:\k8\aboul; %let nom=_TEMPOR_; %let nc=; %end;
%end;
%if &nc>22 %then  %goto arret;
%str(libname a "&lib";);
libname k 'u:\k8\akor';
proc contents data=&tabws out=out noprint;
data out; set out; keep name varnum;
proc sql noprint; select varnum  into :vf from out
                        where upcase(name)='EFFECTIF'; quit;
%if &vf^=2 %then %do;
%put Vous devez utiliser la macro MKAMG avec une grille; %goto arret;
%end;
proc iml;
reset storage=&catiml; load;
reset storage=k.kompa; load module=(tablesas taille);
reset storage=k.kouto; load module=(cxuse queldata quelvq);
reset storage=k.kalm; load module=carvnum;
dsn=datasets(lib);
run queldata(qdat,dsn);
run cxuse(lib,qdat);
noms=contents();
run quelvq(qobs,qvar,noms);
read all var qvar into vq;
read all var qobs into idvq;
close;
if type(idvq)='N' then idvq=char(idvq,taille(max(idvq)));
if type(vq)='N' then run tablesas('work','qq',vq,'var_qual',idvq);
if type(vq)='C' then do;
                run carvnum(vqn,mod,modalite,vq);
                print modalite[rowname=mod colname='VALEUR'];
                run tablesas('work','qq',vqn,'var_qual',idvq);
                end;
run tablesas('work','dd',code,'_codage_',ident);
reset storage=&catiml; store qvar;
quit;
data x; set &taclus; num=_n_; keep cluster num; run;
proc sql; create table bug as select max(cluster) as nbgr from x; quit;
proc sql; create table f2 as select  dd.* , cluster, var_qual
from x, dd , qq where num=_codage_ & qq.idobs=dd.idobs; quit;
proc iml;
use x; name=contents(); idcol=name[1]; read all var idcol into color; close;
reset storage=k.kompa; load module=taille;
reset storage=k.kanif;
load module=(canbfic cacolfic);
reset storage=k.kouto;
load module=(canclu10 camclu10 canclu camclu);
reset storage=&catiml; load;
titre=concat('Camemberts de la variable : ',qvar,' (Ficelle)');
if n<=10 then
print "La taille de la ficelle <=10, il vaut mieux utiliser la macro MKAMF1";
if nu>50 then print "pas de graphique pour une ficelle de plus de 50 unites";
run canbfic('f2',color,n,gkat,titre);
run cacolfic('f2',color,n,gkat,titre);
titr=concat('Croisement de ',qvar,' avec CLUSTER (Ficelle)');
use f2 var {idobs _codage_ cluster var_qual}; read all; close;
use bug; read all var _num_ into nbgp; close;
nclus=nbgp;
if nclus<=10 then
        do;
        run canclu10(cluster,nclus,var_qual,gkat,titr);
        run camclu10(cluster,nclus,var_qual,gkat,titr);
        end;
if nclus>10 & nclus<=50 then
        do;
        run canclu(cluster,nclus,var_qual,gkat,titr);
        run camclu(cluster,nclus,var_qual,gkat,titr);
        end;
quit;
%arret : %put FIN DE LA MACRO;
%mend mkamf2;
